// HCF v3.0
#include <map>
#include <utility>
#include <tclcl.h>
#include "object.h"

using namespace std;

#define MAX_JITTERS 32

typedef unsigned long ulong;
typedef map<ulong, double> jittermap;
typedef jittermap::iterator jittermap_it;


class JitterManager {
public:
	static JitterManager* getInstance();
	void insertDelay(ulong jitter_id, ulong unique_id, double delay);
	double getAvgDelay(ulong jitter_id);
	double getJitter(ulong jitter_id);
	void reset(ulong jitter_id);

protected:
	JitterManager();
	virtual ~JitterManager() {};
	static JitterManager* instance;

	jittermap delay_maps[MAX_JITTERS];
	double avg_delay[MAX_JITTERS];
};
