######################################################################
#                                                                    #
# finish: Called at the end of the simulation, it produces the       #
#         output file by calling others subroutines                  #
#                                                                    #
######################################################################

proc finish {} {
        global file line opt num_n num_udp num_tcp num_voip
	set qline "--------------------"
        set line $qline$qline$qline$qline$qline$qline$qline$qline$qline$qline
        dump_stat
        if {$opt(tcp) == 1} {
                TCP_stat
        }
        if {$opt(udp) == 1} {
                UDP_stat
        }
        if {$opt(voip) == 1} {
                UDP_voip_stat
        }       
	LL_stat
	IFQ_stat
	flush $file(finish)
	MAC_stat
	NET_stat
	ERM_stat
	ERM_change
	if {$opt(tcp) == 1} {
                delay_stat "tcp" $num_tcp
        }
  	if {$opt(udp) == 1} {
                delay_stat "udp" $num_udp
        }
        if {$opt(voip) == 1} {
                delay_voip_stat $num_voip
        }
}

######################################################################
#                                                                    #
# TCP_stat: Writes on the output file the TCP statistics             #
#                                                                    #
######################################################################

proc TCP_stat {} {
        global file line num_tcp fl stat opt nd
        set tcp_temp [list 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14]
        set tcp_dim [list 8 12 12 12 12 12 12 10 9 12.0 12.0 8.3 8 10.4 8]
        set tcp_dim_tit [list 8 12 12 12 12 12 12 10 9 12 12 8 8 10 8]
        set tcp_tip [list s s d d d d d d d f f f f f d]
        set tcp_val ""
        set tcp_tit ""
	foreach k $tcp_temp {
		append tcp_val "%[lindex $tcp_dim $k][lindex $tcp_tip $k] "
		append tcp_tit "%[lindex $tcp_dim_tit $k]s "
	}
        puts $file(finish) "#$line\n#"
        puts $file(finish) "#\t\t\t\tTCP Statistics\n#"
        puts $file(finish) "# [format $tcp_tit flow_id direction pkt_to_send pkt_tx pkt_rcv ack_tx ack_rcv \
                fast_rec timeout throughput goodput avg_wnd max_wnd idle_time n_flow]\n#"
		
        foreach fid [range 1 $num_tcp] {
		puts $file(finish) "  [format $tcp_val tcp_$fid $fl($fid) [expr $stat(tcp,pkt_to_send,$fid) + 1] $stat(tcp,pkt_tx,$fid) \
                        $stat(tcp,pkt_rcv,$fid) $stat(tcp,ack_tx,$fid) $stat(tcp,ack_rcv,$fid) \
                        $stat(tcp,fast_rec,$fid) $stat(tcp,timeout,$fid) \
                        [expr $stat(tcp,pkt_tx,$fid) * 8 * $opt(tcp_size) / [expr $opt(stop).0 - $opt(start) - $stat(tcp,idle_time,$fid)]] \
                        [expr [expr $stat(tcp,pkt_to_send,$fid) + 1] * 8.0 * $opt(tcp_size) / [expr $opt(stop).0 - $opt(start) - $stat(tcp,idle_time,$fid)]] \
                        [expr $stat(tcp,win_avg,$fid) / $stat(tcp,win_count,$fid)] \
                        [expr $stat(tcp,win_max,$fid).0 / $stat(tcp,win_count,$fid)] $stat(tcp,idle_time,$fid) $stat(tcp,n_flow,$fid)]"
        }

        if {$opt(onoff) == 2} {
                foreach fid [range [expr -$num_tcp] -1] {
			puts $file(finish) "  [format $tcp_val tcp_$fid $fl($fid) [expr $stat(tcp,pkt_to_send,$fid) + 1] $stat(tcp,pkt_tx,$fid) \
                                $stat(tcp,pkt_rcv,$fid) $stat(tcp,ack_tx,$fid) $stat(tcp,ack_rcv,$fid) \
                                $stat(tcp,fast_rec,$fid) $stat(tcp,timeout,$fid) \
                                [expr $stat(tcp,pkt_tx,$fid) * 8 * $opt(tcp_size) / [expr $opt(stop).0 - $opt(start) - $stat(tcp,idle_time,$fid)]] \
                                [expr [expr $stat(tcp,pkt_to_send,$fid) + 1] * 8.0 * $opt(tcp_size) / [expr $opt(stop).0 - $opt(start) - $stat(tcp,idle_time,$fid)]] \
                                [expr $stat(tcp,win_avg,$fid) / $stat(tcp,win_count,$fid)] \
                                [expr $stat(tcp,win_max,$fid).0 / $stat(tcp,win_count,$fid)] $stat(tcp,idle_time,$fid) $stat(tcp,n_flow,$fid)]"
                }
        }
}

######################################################################
#                                                                    #
# UDP_stat: Writes on the output file the UDP statistics             #
#                                                                    #
######################################################################

proc UDP_stat {} {
        global file line num_udp udp_fl stat opt nd
        set udp_temp [list 0 1 2 3 4]
        set udp_dim [list 8 12 12 12 12]
        set udp_dim_tit [list 8 12 12 12 12]
        set udp_tip [list s s d d f]
        set udp_val ""
        set udp_tit ""
	foreach k $udp_temp {
		append udp_val "%[lindex $udp_dim $k][lindex $udp_tip $k] "
		append udp_tit "%[lindex $udp_dim_tit $k]s "
	}
        puts $file(finish) "#$line\n#"
        puts $file(finish) "#\t\t\t\tUDP Statistics\n#"
        puts $file(finish) "# [format $udp_tit flow_id direction pkt_tx pkt_rcv throughput]\n#"
        foreach fid [range 1 $num_udp] {
                puts $file(finish) "  [format $udp_val udp_$fid $udp_fl($fid) $stat(udp,pkt_tx,$fid) $stat(udp,pkt_rcv,$fid) \
                        [expr $stat(udp,pkt_rcv,$fid) * 8 * $opt(udp_size) / [expr $opt(stop).0 - $opt(start)]]]"
        }
}

proc UDP_voip_stat {} {
        global file line num_voip voip_fl stat opt nd
        set voip_temp [list 0 1 2 3 4 5 6 7]
        set voip_dim [list 8 12 12 12 12 12 12 12]
        set voip_dim_tit [list 8 12 12 12 12 12 12 12]
        set voip_tip [list s s d d f d d f]
        set voip_val ""
        set voip_tit ""
	foreach k $voip_temp {
		append voip_val "%[lindex $voip_dim $k][lindex $voip_tip $k] "
		append voip_tit "%[lindex $voip_dim_tit $k]s "
	}
        puts $file(finish) "#$line\n#"
        puts $file(finish) "#\t\t\t\tVoIP Statistics\n#"
        puts $file(finish) "# [format $voip_tit flow_id direction pkt_tx_S pkt_rcv_S throughput_S pkt_tx_D pkt_rcv_D throughput_D]\n#"
        foreach fid [range 1 $num_voip] {
                puts $file(finish) "  [format $voip_val voip_$fid $voip_fl($fid) $stat(voipc,pkt_tx,$fid) $stat(voipc,pkt_rcv,$fid) \
                        [expr $stat(voipc,byte_rcv,$fid) * 8 / [expr $opt(stop).0 - $opt(start)]] \
                        $stat(voips,pkt_tx,$fid) $stat(voips,pkt_rcv,$fid) \
                        [expr $stat(voips,byte_rcv,$fid) * 8 / [expr $opt(stop).0 - $opt(start)]]]"
        }
}


######################################################################
#                                                                    #
# LL_stat: Writes on the output file the LLC statistics              #
#                                                                    #
######################################################################

proc LL_stat {} {
        global file line stat num_n nd
        set ll_temp [list 0 1 2 3 4 5 6 7 8]
        set ll_dim [list 8 12 12 12 10 12 12 10 10]
        set ll_dim_tit [list 8 12 12 12 10 12 12 10 10]
        set ll_tip [list s s d d d d d d d]
        set ll_val ""
        set ll_tit ""
        foreach k $ll_temp {
                append ll_val "%[lindex $ll_dim $k][lindex $ll_tip $k] "
 		append ll_tit "%[lindex $ll_dim_tit $k]s "
 	}
        puts $file(finish) "#\n#$line\n#"
        puts $file(finish) "#\t\t\t\tLL Statistics\n#"
        puts $file(finish) "# [format $ll_tit node_id pkt_type rcv_appl tx_ifq tx_arp_down rcv_mac \
                tx_appl tx_arp_up arp_tx_ifq]\n#"
        foreach fid [lessof $num_n] {
                foreach tip {message ARP tcp ack udp voip} {
                        puts $file(finish) "  [format $ll_val ll_$nd($fid) $tip $stat(ll,rcv_appl,$fid,$tip) \
                                $stat(ll,tx_ifq,$fid,$tip) $stat(ll,tx_arp_down,$fid,$tip) $stat(ll,rcv_mac,$fid,$tip) $stat(ll,tx_appl,$fid,$tip) \
                                $stat(ll,tx_arp_up,$fid,$tip) $stat(ll,arp_tx_ifq,$fid,$tip)]"
                }
                puts $file(finish) "#"
        }
}

######################################################################
#                                                                    #
# IFQ_stat: Writes on the output file the Interface Queue statistics #
#                                                                    #
######################################################################

proc IFQ_stat {} {
        global file line stat obj num_bs_queue nd num_n opt
        set bs_ifq_temp [list 0 1 2 3 4 5 6]
        set bs_ifq_dim [list 10 12 12 12 12 12.3 12]
        set bs_ifq_dim_tit [list 10 12 12 12 12 12 12]
        set bs_ifq_tip [list s s d d d f d]
        set bs_ifq_val ""
        set bs_ifq_tit ""
        foreach k $bs_ifq_temp {
                append bs_ifq_val "%[lindex $bs_ifq_dim $k][lindex $bs_ifq_tip $k] "
 		append bs_ifq_tit "%[lindex $bs_ifq_dim_tit $k]s "
 	}
        puts $file(finish) "#$line\n#"
        puts $file(finish) "#\t\t\t\tIFQ Statistics\n#"
        puts $file(finish) "# [format $bs_ifq_tit queue_id pkt_type rcv drop timeout avg_size limit]\n#"
        foreach num [lessof $num_n] {
                $obj(ifq,$num) dump_queue
                set stat(bs_q_limit,$num) [$obj(ifq,$num) set limit_]
                foreach fid [lessof $num_bs_queue] {
                        foreach tip {message ARP tcp ack udp voip} {
                                puts $file(finish) "  [format $bs_ifq_val ifq_$nd($num)_$fid $tip $stat(bs_ifq,rcv,$fid,$tip) \
                                        $stat(bs_ifq,drop,$fid,$tip) $stat(bs_ifq,tout,$fid,$tip) [expr $stat(bs_q_size,$fid) / [expr $stat(bs_q_arrv,$fid) + 0.00000000000000001]] \
                                                $stat(bs_q_limit,$num)]"
                        }
                        puts $file(finish) "#"
                }
                set num_bs_queue 0
        }
}

######################################################################
#                                                                    #
# MAC_stat: Writes on the output file the MAC statistics             #
#                                                                    #
######################################################################

proc MAC_stat {} {
        global file line num_tcp stat num_n nd num_mac_tc obj
        set mac_temp [list 0 1 2 3 4 5 6 7 8 9 10 11 12 13]
        set mac_dim [list 10 10 10 10 10 10 10 12 12 12 12 12 10 10]
        set mac_dim_tit [list 10 10 10 10 10 10 10 12 12 12 12 12 10 10]
        set mac_tip [list s s d d d d d d d d d d d d]
        set mac_val ""
        set mac_tit ""
	set cfb_TCP_tot 0
	set cfb_VoIP_tot 0
        foreach k $mac_temp {
                append mac_val "%[lindex $mac_dim $k][lindex $mac_tip $k] "
 		append mac_tit "%[lindex $mac_dim_tit $k]s "
 	}
        puts $file(finish) "#$line\n#"
        puts $file(finish) "#\t\t\t\tMAC Statistics\n#"
	puts $file(finish) [format "# %12s %12s %12s %12s %12s %12s %12s %12s\n#" marker cap_% cap_avg_dur cap_num cfp_%_max cfp_%_tot cfp_avg_dur cfp_num]
	$obj(mac,0) dump_tc
	puts $file(finish) [format "  %12s %12f %12f %12d %12f %12f %12f %12d" hcf_stats $stat(mac,cap_percent_tot) $stat(mac,cap_avg_time) $stat(mac,cap_num) \
                                                                          $stat(mac,cfp_percent_max) $stat(mac,cfp_percent_tot) $stat(mac,cfp_avg_time) \
                                                                          $stat(mac,cfp_num)]
	set num_mac_tc 0
        puts $file(finish) [format "#\n# %12s %12s %12s %12s %12s %12s %12s %12s %12s %12s %12s\n#" node_id real_coll virt_coll virtcoll \
											cfb_avg_dur cfb_num cfb_bad_end TCP_fast TCP_slow VoIP_fast VoIP_slow]
        foreach num [lessof $num_n] {
		if {$num == 0} {
			$obj(mac,$num) dump_tc
	                foreach fid [lessof $num_mac_tc] {
                        	puts $file(finish) [format "  %12s %12f %12d %12d %12f %12d %12d %12d %12d %12d %12d" col_$nd($num)_$fid $stat(mac,col,$fid) \
										$stat(mac,virt_col,$fid) \
                                                                                $stat(mac,virtcoll) $stat(mac,$fid,cfb_avg_time) $stat(mac,$fid,cfb_num) \
										$stat(mac,$fid,cfb_num_bad_end) \
										$stat(mac,$fid,cfb_data_fast_recv) $stat(mac,$fid,cfb_data_slow_recv) \
										$stat(mac,$fid,cfb_voice_fast_recv) $stat(mac,$fid,cfb_voice_slow_recv)]
                	}
		} else {
			if {$num == 1} {
				puts $file(finish) [format "#\n# %12s %12s %12s %12s %12s %12s %12s %12s %12s %12s\n#" node_id real_coll virt_coll virtcoll \
													cfb_avg_dur cfb_num cfb_bad_end TCP VoIP noData]
			}
	                $obj(mac,$num) dump_tc
			foreach fid [lessof $num_mac_tc] {
				set cfb_TCP_tot [expr $cfb_TCP_tot + $stat(mac,$fid,cfb_data_fast_recv)]
				set cfb_VoIP_tot [expr $cfb_VoIP_tot + $stat(mac,$fid,cfb_voice_fast_recv)]
	                        puts $file(finish) [format "  %12s %12f %12d %12d %12f %12d %12d %12d %12d %12d" col_$nd($num)_$fid $stat(mac,col,$fid) \
										$stat(mac,virt_col,$fid) \
                                                                                $stat(mac,virtcoll) $stat(mac,$fid,cfb_avg_time) $stat(mac,$fid,cfb_num) \
										$stat(mac,$fid,cfb_num_bad_end) \
										$stat(mac,$fid,cfb_data_fast_recv) $stat(mac,$fid,cfb_voice_fast_recv) \
										$stat(mac,$fid,cfb_noDataToSend)]
			}
		}
		set num_mac_tc 0
        }
	puts $file(finish) [format "\n  %12s %90d %12d" totals $cfb_TCP_tot $cfb_VoIP_tot]
	
        puts $file(finish) "#\n# [format $mac_tit node_id pkt_type rcv_ifq mac_busy rtx max_rtx send_net rcv_net rcv_net_col rcv_net_err \
                rcv_net_oth rcv_net_my dupl send_ll]\n#"
        foreach num [lessof $num_n] {
                $obj(mac,$num) dump_tc
                foreach fid [lessof $num_mac_tc] {
                        foreach tip {message ARP tcp ack udp voip mac_rts mac_cts mac_ack} {
                                puts $file(finish) "  [format $mac_val mac_$nd($num)_$fid $tip $stat(mac,rcv_ifq,$fid,$tip) \
                                        $stat(mac,busy,$fid,$tip) $stat(mac,rtx,$fid,$tip) $stat(mac,max_rtx,$fid,$tip) $stat(mac,send_erm,$fid,$tip) \
                                        $stat(mac,rcv_chn,$fid,$tip) $stat(mac,rcv_chn_col,$fid,$tip) $stat(mac,rcv_chn_err,$fid,$tip) \
                                        $stat(mac,rcv_chn_other,$fid,$tip) $stat(mac,rcv_chn_my,$fid,$tip) $stat(mac,dupl,$fid,$tip) $stat(mac,send_ll,$fid,$tip)]"
                        }
                        puts $file(finish) "#"
                }
                set num_mac_tc 0
        }
}

######################################################################
#                                                                    #
# ERM_stat: Writes on the output file the Error Model statistics     #
#                                                                    #
######################################################################

proc ERM_stat {} {
        global file line stat num_n nd opt macadd
        $opt(timer_list) dump_chn
        set erm_temp [list 0 1 2 3 4 5 6 7 8 9 10]
        set erm_dim [list 8 12 12 12 12 12 14.10 12 12 14.10 12]
        set erm_dim_tit [list 8 12 12 12 12 12 14 12 12 14 12]
        set erm_tip [list s s s s d d f d d f d]
        set erm_val ""
        set erm_tit ""
        foreach k $erm_temp {
                append erm_val "%[lindex $erm_dim $k][lindex $erm_tip $k] "
 		append erm_tit "%[lindex $erm_dim_tit $k]s "
 	}
        puts $file(finish) "#$line\n#"
        puts $file(finish) "#\t\t\t\tError Model Statistics\n#"
        puts $file(finish) "# [format $erm_tit who src dst pkt_type rcv_net_other error_other p_error_other rcv_net_my error_my p_error_my send_chn]\n#"
        foreach fid [lessof [expr $num_n * [expr $num_n - 1] / 2]] {
                foreach tip {tcp ack udp voip mac_rts mac_cts mac_ack} {
                        puts $file(finish) "  [format $erm_val erm_$fid $macadd($stat(errmo_src,$fid)) $macadd($stat(errmo_dst,$fid)) $tip \
                                $stat(errmo,$fid,rcv_mac,$tip) $stat(errmo,$fid,corrup,$tip) \
                                [expr $stat(errmo,$fid,corrup,$tip) / [expr $stat(errmo,$fid,rcv_mac,$tip) + 0.000000000001]] \
                                $stat(errmo,$fid,rcv_mac_my,$tip) $stat(errmo,$fid,corrup_my,$tip) \
                                [expr $stat(errmo,$fid,corrup_my,$tip) / [expr $stat(errmo,$fid,rcv_mac_my,$tip) + 0.000000000001]] \
                                $stat(errmo,$fid,send_chn,$tip)]"
                }
                puts $file(finish) "#"
        }

}

######################################################################
#                                                                    #
# NET_stat: Writes on the output file the Wireless Physic statistics #
#                                                                    #
######################################################################

proc NET_stat {} {
        global file line stat num_n nd
        set chn_temp [list 0 1 2 3 4 5]
        set chn_dim [list 8 12 12 12 12 12]
        set chn_dim_tit [list 8 12 12 12 12 12]
        set chn_tip [list s s d d d d]
        set chn_val ""
        set chn_tit ""
        foreach k $chn_temp {
                append chn_val "%[lindex $chn_dim $k][lindex $chn_tip $k] "
 		append chn_tit "%[lindex $chn_dim_tit $k]s "
 	}
        puts $file(finish) "#$line\n#"
        puts $file(finish) "#\t\t\t\tNetwork Statistics\n#"
        puts $file(finish) "# [format $chn_tit node_id pkt_type rcv_chn drop bit_error send_mac]\n#"
        foreach fid [lessof $num_n] {
                foreach tip {message ARP tcp ack udp voip mac_rts mac_cts mac_ack} {
                        puts $file(finish) "  [format $chn_val chn_$nd($fid) $tip $stat(chn,rcv_erm,$fid,$tip) $stat(chn,drop,$fid,$tip) \
                                $stat(chn,error,$fid,$tip) $stat(chn,send_mac,$fid,$tip)]"
                }
                puts $file(finish) "#"
        }
}

######################################################################
#                                                                    #
# ERM_change: Writes on the output file others Error Model           #
#             statistics                                             #
#                                                                    #
######################################################################

proc ERM_change {} {
        global file line stat num_n nd opt macadd
        set cst_temp [list 0 1 2 3 4 5 6]
        set cst_dim [list 8 12 12 14.4 14.4 14.10 14.10]
        set cst_dim_tit [list 8 12 12 14 14 14 14]
        set cst_tip [list s s s f f f f]
        set cst_val ""
        set cst_tit ""
        foreach k $cst_temp {
                append cst_val "%[lindex $cst_dim $k][lindex $cst_tip $k] "
 		append cst_tit "%[lindex $cst_dim_tit $k]s "
 	}
        puts $file(finish) "#$line\n#"
        puts $file(finish) "#\t\t\t\tError Model Time Change\n#"
        puts $file(finish) "# [format $cst_tit who src dst burst_BG burst_BB pGB perr]\n#"
        foreach fid [lessof [expr $num_n * [expr $num_n - 1] / 2]] {
                set burst_BG [expr $stat(errmo,$fid,av_badG).0 / $stat(errmo,$fid,n_badG).0]
                set burst_BB [expr $stat(errmo,$fid,av_badB).0 / [expr $stat(errmo,$fid,n_badB).0 + 0.0000000000000001]]
                set pGB [expr $stat(errmo,$fid,n_badB).0 / [expr $stat(errmo,$fid,n_badB).0 + $stat(errmo,$fid,n_badG).0]]
                set perr [expr [expr $stat(errmo,$fid,av_badG).0 + $stat(errmo,$fid,av_badB).0] / \
                        [expr $stat(errmo,$fid,av_badG).0 + $stat(errmo,$fid,av_badB).0 + $stat(errmo,$fid,av_good).0]]
                puts $file(finish) "  [format $cst_val tch_$fid $macadd($stat(errmo_src,$fid)) $macadd($stat(errmo_dst,$fid)) \
                        $burst_BG $burst_BB $pGB $perr]"
        }
}

######################################################################
#                                                                    #
# delay_stat: Writes on the output file the packets delay and        #
#             variance statistics                                    #
#                                                                    #
#             who: the statistic type (tcp or udp)                   #
#             num: the number of flow of type 'who'                  #
#                                                                    #
######################################################################

proc delay_stat {who num} {
        global file line num_tcp fl udp_fl stat opt nd
        set dly_temp [list 0 1 2 3 4 5 6]
        set dly_dim [list 12 12 12.8 12.8 12.8 12.8 12.8]
        set dly_dim_tit [list 12 12 12 12 12 12 12]
        set dly_tip [list s s f f f f f]
        set var_tip [list s s g g g g g]
        set dly_val ""
        set dly_tit ""
	foreach k $dly_temp {
		append dly_val "%[lindex $dly_dim $k][lindex $dly_tip $k] "
                append var_val "%[lindex $dly_dim_tit $k][lindex $var_tip $k] "
		append dly_tit "%[lindex $dly_dim_tit $k]s "
	}
        if {$who == "tcp"} {
                set temp2 "data"
		set temp3 "TCP"
        } else {
                set temp2 "cbr"
		set temp3 "CBR"
        }
        puts $file(finish) "#\n#$line\n#"
        puts $file(finish) "#\t\t\t\t $temp3 DELAY Statistics\n#"
        puts $file(finish) "# [format $dly_tit flow_id direction LL_delay queue_delay MAC_delay chn_delay up_delay]\n#"
        foreach fid [range 1 $num] {
                if {$who == "tcp"} {
                        set temp $fl($fid)
                } else {
                        set temp $udp_fl($fid)
                }
                puts $file(finish) "  [format $dly_val dly_${temp2}_$fid $temp [expr $stat($who,delay,ll,$fid) / $stat($who,time_count,$fid).0] \
                        [expr $stat($who,delay,ifq,$fid) / $stat($who,time_count,$fid).0] \
                        [expr $stat($who,delay,mac,$fid) / $stat($who,time_count,$fid).0] \
                        [expr $stat($who,delay,channel,$fid) / $stat($who,time_count,$fid).0] \
                        [expr $stat($who,delay,up,$fid) / $stat($who,time_count,$fid).0]]"
        }
	if {$opt(onoff) == 2 && $who == "tcp"} {
                foreach fid [range [expr -$num] -1] {
                        puts $file(finish) "  [format $dly_val dly_${temp2}_$fid $fl($fid) [expr $stat($who,delay,ll,$fid) / $stat($who,time_count,$fid).0] \
                                [expr $stat($who,delay,ifq,$fid) / $stat($who,time_count,$fid).0] \
                                [expr $stat($who,delay,mac,$fid) / $stat($who,time_count,$fid).0] \
                                [expr $stat($who,delay,channel,$fid) / $stat($who,time_count,$fid).0] \
                                [expr $stat($who,delay,up,$fid) / $stat($who,time_count,$fid).0]]"
                }
        }
        puts $file(finish) "#\n#$line\n#"
        puts $file(finish) "#\t\t\t\t $temp3 JITTER Statistics\n#"
        puts $file(finish) "# [format $dly_tit flow_id direction LL_delay queue_delay MAC_delay chn_delay up_delay]\n#"
        foreach fid [range 1 $num] {
                if {$who == "tcp"} {
                        set temp $fl($fid)
                } else {
                        set temp $udp_fl($fid)
                }
                puts $file(finish) "  [format $var_val var_${temp2}_$fid $temp \
                        $stat($who,var,ll,$fid) $stat($who,var,ifq,$fid) $stat($who,var,mac,$fid) \
                        $stat($who,var,channel,$fid) $stat($who,var,up,$fid)]"
        }
	if {$opt(onoff) == 2 && $who == "tcp"} {
                foreach fid [range [expr -$num] -1] {
                        puts $file(finish) "  [format $var_val var_${temp2}_$fid $fl($fid) \
                                $stat($who,var,ll,$fid) $stat($who,var,ifq,$fid) $stat($who,var,mac,$fid) \
                                $stat($who,var,channel,$fid) $stat($who,var,up,$fid)]"
                }
        }
}

proc delay_voip_stat {num} {
        global file line num_voip fl voip_fl stat opt nd
	global delaydistup delaydistdown BINSIZE NUMBINS maxup maxdown
        set dly_voip_temp [list 0 1 2 3 4 5 6 7 8 9 10 11]
        set dly_voip_dim [list 12 12 12.8 12.8 12.8 12.8 12.8 12.8 12.8 12.8 12.8 12.8]
        set dly_voip_dim_tit [list 12 12 12 12 12 12 12 12 12 12 12 12]
        set dly_voip_tip [list s s f f f f f f f f f f]
        set var_voip_tip [list s s g g g g g g g g g g]
        set dly_voip_val ""
        set dly_voip_tit ""
	foreach k $dly_voip_temp {
		append dly_voip_val "%[lindex $dly_voip_dim $k][lindex $dly_voip_tip $k] "
                append var_voip_val "%[lindex $dly_voip_dim_tit $k][lindex $var_voip_tip $k] "
		append dly_voip_tit "%[lindex $dly_voip_dim_tit $k]s "
	}

        puts $file(finish) "#\n#$line\n#"
        puts $file(finish) "#\t\t\t\t VoIP DELAY Statistics\n#"
        puts $file(finish) "# [format $dly_voip_tit flow_id direction LL_delay_S queue_delay_S MAC_delay_S chn_delay_S up_delay_S LL_delay_D queue_delay_D MAC_delay_D chn_delay_D up_delay_D]\n#"
        foreach fid [range 1 $num] {
		if { $stat(voipc,time_count,$fid) == 0 } { set stat(voipc,time_count,$fid) 1 }
		if { $stat(voips,time_count,$fid) == 0 } { set stat(voips,time_count,$fid) 1 }
                puts $file(finish) "  [format $dly_voip_val dly_voce_$fid $voip_fl($fid) \
                        [expr $stat(voipc,delay,ll,$fid) / $stat(voipc,time_count,$fid).0] \
                        [expr $stat(voipc,delay,ifq,$fid) / $stat(voipc,time_count,$fid).0] \
                        [expr $stat(voipc,delay,mac,$fid) / $stat(voipc,time_count,$fid).0] \
                        [expr $stat(voipc,delay,channel,$fid) / $stat(voipc,time_count,$fid).0] \
                        [expr $stat(voipc,delay,up,$fid) / $stat(voipc,time_count,$fid).0] \
                        [expr $stat(voips,delay,ll,$fid) / $stat(voips,time_count,$fid).0] \
                        [expr $stat(voips,delay,ifq,$fid) / $stat(voips,time_count,$fid).0] \
                        [expr $stat(voips,delay,mac,$fid) / $stat(voips,time_count,$fid).0] \
                        [expr $stat(voips,delay,channel,$fid) / $stat(voips,time_count,$fid).0] \
                        [expr $stat(voips,delay,up,$fid) / $stat(voips,time_count,$fid).0]]"
        }
        puts $file(finish) "#\n#$line\n#"
        puts $file(finish) "#\t\t\t\t VoIP JITTER Statistics\n#"
        puts $file(finish) "# [format $dly_voip_tit flow_id direction LL_delay_S queue_delay_S MAC_delay_S chn_delay_S up_delay_S LL_delay_D queue_delay_D MAC_delay_D chn_delay_D up_delay_D]\n#"
        foreach fid [range 1 $num] {
                puts $file(finish) "  [format $var_voip_val var_voce_$fid $voip_fl($fid) \
                        $stat(voipc,var,ll,$fid) $stat(voipc,var,ifq,$fid) $stat(voipc,var,mac,$fid) $stat(voipc,var,channel,$fid) \
                        $stat(voipc,var,up,$fid) $stat(voips,var,ll,$fid) $stat(voips,var,ifq,$fid) $stat(voips,var,mac,$fid) \
                        $stat(voips,var,channel,$fid) $stat(voips,var,up,$fid)]"
        }
	
	# delay distribution
	set numup 0.0
	set numdown 0.0
	for { set i 0 } { $i <= $NUMBINS } { incr i } { 
		set numup [expr $numup + $delaydistup($i)]
		set numdown [expr $numdown + $delaydistdown($i)]
	}	
	set outlier [expr $NUMBINS + 1]
	set outliersup $delaydistup($outlier)
        set outliersdown $delaydistup($outlier)
 
	puts $file(finish) "#\n\n\n\n#$line\n#"
       	puts $file(finish) "#\t\t\t\t VoIP DELAY Distribution"
	puts $file(finish) "# Samples up = [expr int($numup)] - Samples down = [expr int($numdown)]"
	puts $file(finish) "# Outliers up = $outliersup - Outliers down = $outliersdown"
        puts $file(finish) "# Max delay up = $maxup - Max delay down = $maxdown"
       	puts $file(finish) "# bin       infbin      nup      pdfup         cumup       ndown     pdfdown        cumdown"
	
	set cumup 0.0
	set cumdown 0.0
	set aveup 0.0
	set avedown 0.0
	for { set i 0 } { $i <= $NUMBINS } { incr i } { 
        	set nup $delaydistup($i)
		if { $nup > 0 } {
			set pdfup [expr $nup/$numup]
			set cumup [expr $cumup + $pdfup]
			set aveup [expr $aveup + $pdfup * ($i + 0.5) * $BINSIZE]
		} else {
			set pdfup 0.0
		}
		
		set ndown $delaydistdown($i)
		if { $ndown > 0 } {
			set pdfdown [expr $ndown/$numdown]
			set cumdown [expr $cumdown + $pdfdown]
			set avedown [expr $avedown + $pdfdown * ($i + 0.5) * $BINSIZE]
		} else {
			set pdfdown 0.0
		}
		
		if { $nup > 0 || $ndown > 0 } {
			puts $file(finish) [format "%5d   %10.4f   %6d   %1.10f  %1.10f  %6d   %1.10f   %1.10f" \
                        	$i  [expr $i * $BINSIZE]  $nup  $pdfup  $cumup  $ndown  $pdfdown  $cumdown]
		}		
	}		
	puts $file(finish) "# average delay up = $aveup - average delay down = $avedown"
}

set NUMBINS 16000
set BINSIZE 0.0001 ;# 0.1 millisec
set maxup 0.0
set maxdown 0.0

for { set i 0 } { $i <= [expr $NUMBINS + 1] } { incr i } { 
	set delaydistup($i) 0
	set delaydistdown($i) 0
}	 

proc udpdelaysample { addr fid value } {
	global delaydistup delaydistdown BINSIZE NUMBINS maxup maxdown
        
	# puts "delay sample at $addr, fid $fid, value $value"
	
	# dir = 0 -> upstream / dir = 1 -> downstream 
	set dir [string index $addr 0]
	
	set bin [expr int($value/$BINSIZE)]
	if { $bin > $NUMBINS } { 
		puts "Warning: delay out of range : $value"
		set bin [expr $NUMBINS + 1]
	}
	
	if $dir { 
		incr delaydistdown($bin) 
		if { $value > $maxdown } { set maxdown $value }
	} else { 
		incr delaydistup($bin) 
		if { $value > $maxup } { set maxup $value }
	} 
}




